local model = require("model")

local view = require("view")

local nx, ny = 1, 1
local vw, vh = 800/nx, 600/ny
local view = view:new(vw - 2, vh - 2)
view:load("ChessAlpha2.ttf", "iIkKjJlLmMnN")

local models = {}
for i = 1, nx*ny do
  models[i] = model:new()
end

function love.mousepressed()
  local s = nx*ny
  nx, ny = nx + 1, ny + 1
  for i = s, nx*ny do
    models[i] = model:new()
  end
  vw, vh = 800/nx, 600/ny
  view.w = vw - 2
  view.h = vh - 2
  view:load("ChessAlpha2.ttf", "iIkKjJlLmMnN")
end

function love.draw()
  for i = 1, nx*ny do
    local _i = i - 1
    local x = _i%nx
    local y = (_i - x)/nx
    love.graphics.origin()
    love.graphics.translate(x*vw, y*vh)
    view:draw(models[i])
  end
end

function love.update(dt)
  for i = 1, nx*ny do
    models[i]:random()
  end
end